unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, Forms, Controls, Machines,
  RiscMain;

type

  { TForm1 }

  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
  private
    { private declarations }
    RiscCore: TMachine;
    procedure  IdleProc(sender:TObject; var Done: Boolean);
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.IdleProc(sender:TObject; var Done: Boolean);
begin
  RiscCore.IdleProc(Self);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  RiscCore:=TRiscCore.Create(Self,'oberon.fs');
  Application.OnIdle:=@IdleProc;
  Cursor:= crNone;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  RiscCore.Destroy;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  RiscCore.KeyDown(Self,Key,Shift);
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  RiscCore.MouseDown(Self,Button,Shift,X,Y);
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
begin
  RiscCore.MouseMove(Self,Shift,X,Y);
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  RiscCore.MouseUp(Self,Button,Shift,X,Y);
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  RiscCore.Paint(Self);
end;

end.

