unit RiscKeyCode;

{$mode objfpc}{$H+}

interface

uses
  Classes, RiscCpu, RiscFp;

  function RiscKeyDown(Key: Word; Shift: TShiftState; var Buff: keybuf): uint32_t;

implementation

var
  ShiftStatus: boolean;
  CapsStatus : boolean;

const
  Key_R: ARRAY[33..40] of word = (
    $7D,$7A,$69,$6C,$6B,$75,$74,$72
  );

  Key_0_9: ARRAY[48..57] of word = (
    $45,$16,$1E,$26,$25,
    $2E,$36,$3D,$3E,$46
  );

  Key_a_z: ARRAY[65..90] of word = (
    $1C,$32,$21,$23,$24,$2B,$34,$33,$43,
    $3B,$42,$4B,$3A,$31,$44,$4D,$15,$2D,
    $1B,$2C,$3C,$2A,$1D,$22,$35,$1A
  );

  Key_F: ARRAY[112..123] of word = (
    $05,$06,$04,$0c,$03,$0B,
    $83,$0A,$01,$09,$78,$07
  );

  Key_S: ARRAY[186..192] of word = (
    $4C,$55,$41,$4E,$49,$4A,$0E
  );

  Key_B: ARRAY[219..222] of word = (
    $54,$5D,$5B,$52
  );

function RiscKeyDown(Key: Word; Shift: TShiftState; var Buff: keybuf): uint32_t;
var
  Code: word;
begin

  if Key=20 then CapsStatus:= not CapsStatus;

  if (Key=20) and CapsStatus then begin
    Buff[0]:= $E0;
    Buff[1]:= $F0;
    Buff[2]:= 0;
    Buff[3]:= $E0;
    Buff[4]:= $59;
    Result := 5;
    Exit;
  end else if (Key=20) and not CapsStatus then begin
    Buff[0]:= $E0;
    Buff[1]:= $F0;
    Buff[2]:= $12;
    Buff[3]:= $E0;
    Buff[4]:= 0;
    Result := 5;
    Exit;
  end;

  if (ssShift in Shift) and not ShiftStatus then begin
    Buff[0]:= $E0;
    Buff[1]:= $F0;
    Buff[2]:= 0;
    Buff[3]:= $E0;
    Buff[4]:= $59;
    ShiftStatus:=true;
    Result := 5;
    Exit;
  end;

  case Key of
    33..40   : Code:=Key_R[Key];
    48..57   : Code:=Key_0_9[Key];
    65..90   : Code:=Key_a_z[Key];
    112..123 : Code:=Key_F[Key];
    186..192 : Code:=Key_S[Key];
    219..222 : Code:=Key_B[Key];
    8        : Code:=$66;
    9        : Code:=$0D;
    13       : Code:=$5A;
    27       : Code:=$76;
    32       : Code:=$29;
    45       : Code:=$70;
    46       : Code:=$71;
  else
    Exit;
  end;

  if not (ssShift in Shift) and ShiftStatus then begin
    Buff[0]:= $E0;
    Buff[1]:= $F0;
    Buff[2]:= $12;
    Buff[3]:= $E0;
    Buff[4]:= Code;
    ShiftStatus:=false;
    Result := 5;
    Exit;
  end;

  Buff[0]:= Code;
  Result :=1;

end;

end.

